//ShoopLazer.cs

//audio
datablock AudioProfile(ShoopLazerFireSound)
{
   filename    = "./ShoopLazerFire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(ShoopLazerHitSound)
{
   filename    = "./ShoopLazerHit.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(ShoopLazerChargeSound)
{
   filename    = "./ShoopLazerCharge.wav";
   description = AudioClose3d;
   preload = true;
};


datablock ParticleData(ShoopLazerTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.1 0.1 1.0 0.9";
	colors[1]     = "0.0 0.0 0.8 0.0";
	sizes[0]      = 3.0;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(ShoopLazerTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 3.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ShoopLazerTrailParticle";
};

datablock ParticleData(ShoopLazerChargeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 900;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.1 0.1 1.0 0.9";
	colors[1]     = "0.0 0.0 0.8 0.0";
	sizes[0]      = 3.0;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(ShoopLazerChargeEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 10.0;
   velocityVariance = 10.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ShoopLazerChargeParticle";
};


//muzzle flash effects
datablock ParticleData(ShoopLazerFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 60;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.1 0.1 1.0 0.9";
	colors[1]     = "0.0 0.0 0.8 0.0";
	sizes[0]      = 3.0;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(ShoopLazerFlashEmitter)
{
   ejectionPeriodMS = 6000;
   periodVarianceMS = 0;
   ejectionVelocity = 5.0;
   velocityVariance = 3.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ShoopLazerFlashParticle";

   uiName = "ShoopLazer Flash";
};

datablock ParticleData(ShoopLazerSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.1 0.1 1.0 0.9";
	colors[1]     = "0.0 0.0 0.8 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(ShoopLazerSmokeEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 1800;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ShoopLazerSmokeParticle";

   uiName = "ShoopLazer Smoke";
};


datablock ParticleData(ShoopLazerExplosionParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 1.0;
	lifetimeMS           = 1400;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.1 0.1 1.0 0.9";
	colors[1]     = "0.0 0.0 0.8 0.0";
	sizes[0]      = 6.0;
	sizes[1]      = 0.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(ShoopLazerExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 50;
   ejectionVelocity = 35;
   velocityVariance = 5.0;
   ejectionOffset   = 7.0;
   thetaMin         = 89;
   thetaMax         = 200;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ShoopLazerExplosionParticle";

   useEmitterColors = true;
   uiName = "ShoopLazer Hit Dust";
};


datablock ParticleData(ShoopLazerExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 350;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.1 0.1 1.0 0.9";
	colors[1]     = "0.0 0.0 0.8 0.0";
	sizes[0]      = 0;
	sizes[1]      = 15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(ShoopLazerExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.0;
   ejectionOffset   = 7.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ShoopLazerExplosionRingParticle";

   useEmitterColors = true;
   uiName = "ShoopLazer Hit Flash";
};

datablock ExplosionData(ShoopLazerExplosion)
{
   //explosionShape = "";
	soundProfile = ShoopLazerHitSound;

   lifeTimeMS = 150;

   particleEmitter = ShoopLazerExplosionEmitter;
   particleDensity = 40;
   particleRadius = 0.5;

   emitter[0] = ShoopLazerExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "5 5 5";

   shakeCamera = true;
   camShakeFreq = "30.0 20.0 25.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 3.0;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";

   damageRadius = 10;
   radiusDamage = 50;

   impulseRadius = 6;
   impulseForce = 4000;
};


AddDamageType("ShoopLazer",  'Blargged %1',    '%2 Blargged %1!',1,1);
datablock ProjectileData(ShoopLazerProjectile)
{
   projectileShapeName = "";
   directDamage        = 200;
   directDamageType    = $DamageType::ShoopLazer;
   radiusDamageType    = $DamageType::ShoopLazer;

   brickExplosionRadius = 10;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;
   brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 20;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = ShoopLazerExplosion;
   particleEmitter     = ShoopLazerTrailEmitter;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 10000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Shoop Lazer";
};

//////////
// item //
//////////
datablock ItemData(ShoopLazerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/brickweapon.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Shoop Lazer";
	iconName = "./Icon_ShoopLazer";
	doColorShift = true;
	colorShiftColor = "0.0 0.0 1 1.000";

	 // Dynamic properties defined by the scripts
	image = ShoopLazerImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ShoopLazerImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.5 0 0.3";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = ShoopLazerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.0 0.0 1 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Charge";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 2.0;
	stateAllowImageChange[2]        = false;
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= ShoopLazerChargeEmitter;
	stateEmitterTime[2]				= 0.35;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= ShoopLazerChargeSound;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Smoke";
	stateTimeoutValue[3]            = 0.7;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= ShoopLazerFlashEmitter;
	stateEmitterTime[3]				= 0.5;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= ShoopLazerFireSound;

	stateName[8] = "Smoke";
	stateEmitter[8]					= ShoopLazerSmokeEmitter;
	stateEmitterTime[8]				= 0.05;
	stateEmitterNode[8]				= "muzzleNode";
	stateTimeoutValue[8]            = 0.7;
	stateTransitionOnTimeout[8]     = "Reload";

	stateName[9]			= "Reload";
	stateSequence[9]                = "Reload";
	stateTransitionOnTriggerUp[9]     = "Ready";
	stateSequence[9]	= "Ready";

};

function ShoopLazerImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
	Parent::onFire(%this,%obj,%slot);	
}
